
#include "BBCManager.h"

namespace BBC {

template <> Manager* CSingleton<Manager>::ms_Singleton = NULL;

Manager* Manager::getSingletonPtr(void)
{
    return ms_Singleton;
}

Manager& Manager::getSingleton(void)
{  
    assert( ms_Singleton );  return ( *ms_Singleton );  
}

Manager::Manager() 
{   
}

Manager::~Manager() 
{
}

void Manager::shutdown()
{
}

void Manager::initialize()
{
}

Ogre::Mesh* Manager::loadMesh(Ogre::String folderName, Ogre::String fileName)
{	
	//std::ifstream ifs;
	//ifs.open(Ogre::String(folderName + fileName).c_str(), std::ios_base::in | std::ios_base::binary);
	//Ogre::DataStreamPtr stream(new Ogre::FileStreamDataStream(folderName + fileName, &ifs, false));
	//Ogre::MeshPtr mesh = OBA::OgreBase::getSingleton().getMeshManager()->create(fileName, Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);
	//OBA::OgreBase::getSingleton().getMeshSerializer()->importMesh(stream, mesh.getPointer());

	Ogre::ResourceGroupManager::getSingleton().addResourceLocation(folderName, "FileSystem", fileName, false);

	Ogre::MeshPtr mesh = OBA::OgreBase::getSingleton().getMeshManager()->load(fileName, fileName);

	return mesh.getPointer();
}

Ogre::Mesh* Manager::loadXMLMesh(Ogre::String name)
{
	Ogre::MeshPtr newMesh = Ogre::MeshManager::getSingleton().createManual(name.substr(0,((name.size()-1)-4)),Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME);

	Ogre::VertexElementType colourElementType;
	if (true)
	{
		// DirectX Colour Format
		colourElementType = Ogre::VET_COLOUR_ARGB;
	}
	else
	{
		// OpenGL Colour Format
		colourElementType = Ogre::VET_COLOUR_ABGR;
	}

    OBA::OgreBase::getSingleton().getXMLMeshSerializer()->importMesh(name, colourElementType, newMesh.getPointer());

	return newMesh.getPointer();
}

void Manager::saveMesh(Ogre::String name)
{
	Ogre::MeshPtr meshPtr = Ogre::MeshManager::getSingleton().getByName(name);
	OBA::OgreBase::getSingleton().getMeshSerializer()->exportMesh(meshPtr.getPointer(),name);
}

void Manager::saveXMLMesh(Ogre::String name)
{
	Ogre::MeshPtr meshPtr = Ogre::MeshManager::getSingleton().getByName(name);
	OBA::OgreBase::getSingleton().getXMLMeshSerializer()->exportMesh(meshPtr.getPointer(),name + ".xml");
}

}